"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var react_1 = require("@storybook/react");
var with_readme_1 = require("storybook-readme/with-readme");
var storybook_chrome_screenshot_1 = require("storybook-chrome-screenshot");
var __1 = require("../");
var CodeWithCopy_md_1 = require("./README/CodeWithCopy.md");
react_1.storiesOf('Core/CodeWithCopy', module)
    .addDecorator(with_readme_1.default(CodeWithCopy_md_1.default))
    .addDecorator(storybook_chrome_screenshot_1.withScreenshot())
    .add('Standard', function () {
    return (React.createElement(__1.Provider, null,
        React.createElement(__1.Box, { m: 3 },
            React.createElement(__1.CodeWithCopy, { text: '22ab7io', copy: 'This value has been copied to your clipboard!' })),
        React.createElement(__1.Box, { m: 3 },
            React.createElement(__1.CodeWithCopy, { text: 3555432, copy: 'This value has been copied to your clipboard!' })),
        React.createElement(__1.Box, { m: 3 },
            React.createElement(__1.CodeWithCopy, { copy: 'Specify only the copy prop' })),
        React.createElement(__1.Box, { m: 3 },
            React.createElement(__1.CodeWithCopy, { text: 'Or only the text prop' }))));
})
    .add('Inside clickable element', function () {
    return (React.createElement(__1.Provider, null,
        React.createElement(__1.Box, { m: 3 },
            React.createElement(__1.Link, { href: '#foobar', style: { display: 'block' } },
                React.createElement(__1.Flex, null,
                    React.createElement(__1.Box, { mr: 5 }, "Link Text"),
                    React.createElement(__1.Box, null,
                        React.createElement(__1.CodeWithCopy, { color: '#333', text: '22ab7io', copy: 'This value has been copied to your clipboard!' })))))));
})
    .add('Show icon on hover', function () {
    return (React.createElement(__1.Provider, null,
        React.createElement(__1.Box, { m: 3 },
            React.createElement(__1.CodeWithCopy, { text: '22ab7io', copy: 'This value has been copied to your clipboard!', showCopyButton: 'hover' }))));
});
